<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*" %>
<%@ page import="jcw.WbemScripting.ISWbemLocator" %>
<%@ page import="jcw.WbemScripting.ISWbemObject" %>
<%@ page import="jcw.WbemScripting.ISWbemObjectSet" %>
<%@ page import="jcw.WbemScripting.ISWbemProperty" %>
<%@ page import="jcw.WbemScripting.ISWbemServices" %>
<%@ page import="jcw.WbemScripting.SWbemLocator" %>
<%@ page import="jcw.WbemScripting.jcw.ISWbemObjectJCW" %>
<%@ page import="com.inzoom.comjni.ComJniException" %>
<%@ page import="com.inzoom.comjni.IEnumVARIANT" %>
<%@ page import="com.inzoom.comjni.IUnknown" %>
<%@ page import="com.inzoom.comjni.Variant" %>
<%@ page import="com.inzoom.comjni.jcw.IEnumVARIANTJCW" %>

<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.PredicateBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.actions.WebUIUtility" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<!-- This panel provides a searchable interface into the WMI service -->

<page>
<window-popup onload="updateCurrentNodeGroupsNames();">

<%@ include file="Configuration.jsp"%>

<%
  /**
   * This allows the user to control how the displayed values are sourced.
   */
  final boolean USE_PREDEFINED_LIST_VALUES = false;

  // This is used to match the proper predicate information for nodeGroupNames list type predicate
  final String NODE_GROUPS_PREDICATE_NAME = "NODE_GROUPS";

  // build a filter if necessary
  String filterValue = request.getParameter("NodeGroupsNameFilterValue");
  String filterOps = request.getParameter("NodeGroupsNameFilterOperator");
  if(filterValue != null)
  {
    String value = filterValue;
    String ops = "EQ;";
    if(filterOps.equals("STARTS_WITH"))
    {
      ops = "LIKE;";
      value = value + "*";
    }
    else if(filterOps.equals("ENDS_WITH"))
    {
      ops = "LIKE;";
      value = "*" + value;
    }
    else if(filterOps.equals("CONTAINS"))
    {
      ops = "LIKE;";
      value = "*" + value +"*";
    }
  } else {
    filterValue = "";
    filterValue = "";
  }

  // retrieve the nodeGroupName list from the WMI interface
  ArrayList<String> wmiNodeGroupsNames = new ArrayList<String>();

  if(USE_PREDEFINED_LIST_VALUES)
  {
    final Iterator<PredicateBean> iter = subscriptionBean.getListPredicateIterator();
    while(iter.hasNext())
    {
      final PredicateBean predicate = iter.next();
      if(predicate.getPredicateName().equals(NODE_GROUPS_PREDICATE_NAME))
      {
        wmiNodeGroupsNames.addAll(predicate.getPredicateValues());
        break;
      }
    }
  }

  if(wmiNodeGroupsNames.isEmpty() && !USE_PREDEFINED_LIST_VALUES)
  {
    try
    {
        WebUIUtility.initializeJacozoomIfNecessary();
        ISWbemLocator locator = new SWbemLocator();
        ISWbemServices service = locator.connectServer(OM_HOST_URL, OM_NAME_SPACE_URL, OM_USER_NAME, OM_PASSWORD);
        ISWbemObjectSet objects = service.execQuery("SELECT CAPTION FROM OV_NODEGROUP");

        if(objects.getCount() > 0)
        {
            IUnknown unk = objects.get_NewEnum();
            objects.release();
            IEnumVARIANT ev = IEnumVARIANTJCW.getIEnumVARIANTFromUnknown(unk);
            unk.release();
            int[] fetched = new int[1];
            Variant[] rv = new Variant[] { new Variant() };
            do
            {
                ev.next(1, rv, fetched);
                if(fetched[0] != 0)
                {
                    unk = rv[0].getUnknown();
                    // this causes ComJniException rv[0].release();
                    ISWbemObject obj = ISWbemObjectJCW.getISWbemObjectFromUnknown(unk);
                    unk.release();
                    try
                    {
                        ISWbemProperty property = obj.getProperties_().item("CAPTION");
                        Variant var = property.getValue();
                        String value = var.getString();
                        wmiNodeGroupsNames.add(StringEscapeUtils.escapeXml(value));
                    }
                    finally
                    {
                        obj.release();
                    }
                }
            } while(fetched[0] != 0);
        }

        service.release();
        locator.release();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      out.println("<div class=\"system-msg-error\">Unexpected exception occurred: " + ex.getMessage() + "</div>");
    }
  }

  // build the selected list of host names from existing subscription
  ArrayList<String> selectedNodeGroupsNames = new ArrayList<String>();

  if(request.getParameter("selectedNodeGroupsNames") != null)
  {
    selectedNodeGroupsNames.addAll(Arrays.asList(request.getParameterValues("selectedNodeGroupsNames")));
  }
  else
  {
    final Iterator<PredicateBean> iter = subscriptionBean.getListPredicateIterator();
    while(iter.hasNext())
    {
      final PredicateBean predicate = iter.next();
      if(predicate.getPredicateName().equals(NODE_GROUPS_PREDICATE_NAME))
      {
        selectedNodeGroupsNames.addAll(predicate.getSelectedValues());
        break;
      }
    }
  }

%>

<script type="text/javascript">
  function escapeREText(text)
  {
    if (!arguments.callee.sRE) {
      var specials = [
        '/', '.', '*', '+', '?', '|',
        '(', ')', '[', ']', '{', '}', '\\'
      ];
      arguments.callee.sRE = new RegExp(
        '(\\' + specials.join('|\\') + ')', 'g'
      );
    }
    return text.replace(arguments.callee.sRE, '\\\\$1');
  }

  function selectAllTargetOptions(theForm, name)
  {
    var target = theForm[name];
    // first select all of the options that match the regexp
    selectAllOptions(target);
  }

  // Adds the list of selected items selected in the parent
  // window to its list.
  function updateCurrentNodeGroupsNames()
  {
    var theForm = document.forms['POPUP_FORM'];
    var target = theForm['nodeGroupsNames'];
    var parentForm = self.opener.document.forms[0];
    var source = parentForm['PREDICATE_VALUE_<%=NODE_GROUPS_PREDICATE_NAME%>'];
    // clear the left list
    removeAllOptions(target);
    if(source.options.length != 0)
    {
      // copy from source to left list
      copyAllOptions(source, target);
    }
  }

  function setSelectionOptions(source, target)
  {
    // clear the left list
    removeAllOptions(target);
    // copy from source to left list
    copySelectedOptions(source, target);
  }

  function updateParentForm(theForm)
  {
    selectAllTargetOptions(theForm, 'nodeGroupsNames');
    var source = theForm['nodeGroupsNames'];
    self.opener.updateCurrentNodeGroups(source);
    self.close();
    return true;
  }

  function updateAvailableNodeGroupsNames(theForm)
  {
    var from = theForm['wmiNodeGroupsNames'];
    var to = theForm['nodeGroupsNames.unselected'];
    var target = theForm['nodeGroupsNames'];

    var regex = getFilterRegexp(theForm);
    // first select all of the options that match the regexp
    selectOnlyMatchingOptions(from, regex);
    // unselect items that already exist in the right list
    unselectMatchingOptions(from, target);
    // clear the left list
    removeAllOptions(to);
    // copy from source to left list
    copySelectedOptions(from, to);
    return false;
  }

  function getFilterRegexp(theForm)
  {
    var ops = theForm['NodeGroupsNameFilterOperator'].value;
    var value = theForm['NodeGroupsNameFilterValue'].value;

    var regex = ".*";
    if(value != "") {
      regex = "";
      if(ops == "CONTAINS" || ops == "ENDS_WITH") {
        regex = ".*";
      }
      regex = regex + escapeREText(value);
      if(ops == "CONTAINS" || ops == "STARTS_WITH") {
        regex = regex + ".*";
      }
    }
    return "^" + regex + "$";
  }

  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  function unselectMatchingOptions(from, to)
  {
    for (var i=0; i&lt;from.options.length; i++)
    {
      var o = from.options[i];
      if (o.selected) {
        for (var j=0; j&lt;to.options.length; j++) {
          var op = to.options[j];
          if (o.value == op.value) {
            o.selected = false;
          }
        }
      }
    }
  }

  function transferRight()
  {
    nodeGroupsNames_jsWidget.forms_transferRight();
  }

  function transferLeft()
  {
    removeMatchingOptions(nodeGroupsNames_jsWidget.form, nodeGroupsNames_jsWidget.right);
    nodeGroupsNames_jsWidget.forms_transferLeft();
  }

  // this will remove any options from the specified list that do not match the search filter criteria
  function removeMatchingOptions(theForm, from)
  {
    var re = new RegExp(getFilterRegexp(theForm));
    for(var i=(from.options.length-1); i>=0; i--)
    {
      var o = from.options[i];
      if(o.selected) {
        if(!re.test(o.text)) {
          from.options[i] = null;
        }
      }
    }
  }

</script>

  <form-template name="POPUP_FORM"
                 onsubmit="selectAllTargetOptions(this, 'nodeGroupsNames');"
                 form-action="alarmpoint/jsp/subscription/omw2/OMSearchNodeGroups.jsp;jsessionid=<%= session.getId() %>">

<group label="Search Node Groups">

  <div class="no-list-table-data-title">
    <caption>
      <span>Enter Node Group to search for and press "Get Node Groups"</span>
    </caption>
  </div>

  <div class="form-group">
    <table>
      <tr>
        <th>Name</th><th>Operator</th><th>Value</th>
      </tr>
      <tr>
        <td>Node Groups</td>
        <td type="template">
          <select id="NodeGroupsNameFilterOperator" name="NodeGroupsNameFilterOperator">
            <option
<%
 if(filterOps == null || filterOps.equals("CONTAINS") || filterOps.equals(""))
 {
%>
 selected="true"
<%
 }
%>
              value="CONTAINS">CONTAINS</option>
            <option
<%
 if(filterOps != null && filterOps.equals("ENDS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="ENDS_WITH">ENDS_WITH</option>
            <option
<%
 if(filterOps != null && filterOps.equals("STARTS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="STARTS_WITH">STARTS_WITH</option>
            <option
<%
 if(filterOps != null && filterOps.equals("MATCHES"))
 {
%>
 selected="true"
<%
 }
%>
              value="MATCHES">MATCHES</option>
          </select>
        </td>
        <td type="template">
          <input id="NodeGroupsNameFilterValue" name="NodeGroupsNameFilterValue" value="<%= filterValue %>"/>
        </td>
      </tr>
    </table>
  </div>

  <action-button id="refreshButton" label="Get Node Groups" onclick="updateAvailableNodeGroupsNames(this.form); return false;" />

</group>

<div class="form-group">

  <script type="text/javascript">var nodeGroupsNames_jsWidget;</script>

  <div class="double-list-widget">
    <label>Available Node Groups:</label>
    <br clear="all"/>
    <select multiple="0" name="nodeGroupsNames.unselected" id="nodeGroupsNames.unselected:input" size="10" ondblclick="transferRight();">
    </select>
  </div>

  <div class="double-list-button-cluster">
    <div class="float-none">
      <span id="addButton">
        <input id="addButton:input" class="double-list-action" name="addButton" type="button"
               onclick="transferRight(); return false;" value="Add &gt;"/>
      </span>
      <br/>
      <span id="removeButton">
        <input id="removeButton:input" class="double-list-action" name="removeButton" type="button"
               onclick="transferLeft(); return false;" value="&lt; Remove"/>
      </span>
    </div>
  </div>

  <div class="double-list-widget">
    <label>Selected Node Groups:</label>
    <br clear="all"/>
    <select multiple="0" name="nodeGroupsNames" id="nodeGroupsNames:input" size="10" ondblclick="transferLeft();">
<%
  Collections.sort(selectedNodeGroupsNames, String.CASE_INSENSITIVE_ORDER);
  for (String name : selectedNodeGroupsNames)
  {
%>
      <option value="<%= name%>"><%= name%></option>
<%
  }
%>
    </select>
  </div>
  <script type="text/javascript">nodeGroupsNames_jsWidget = forms_createOptionTransfer('nodeGroupsNames', false);</script>
</div>

<!-- hidden component for javascript processing -->
<div style="display:none;visibility:hidden;">
    <select multiple="0" name="wmiNodeGroupsNames" size="0">
<%
  Collections.sort(wmiNodeGroupsNames, String.CASE_INSENSITIVE_ORDER);
  for (String name : wmiNodeGroupsNames)
  {
%>
      <option value="<%= name%>"><%= name%></option>
<%
  }
%>
    </select>
</div>

  <action-button id="submitButton" label="Save" onclick="return updateParentForm(this.form);" />

  </form-template>

</window-popup>
</page>
