<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="jcw.WbemScripting.ISWbemLocator" %>
<%@ page import="jcw.WbemScripting.ISWbemObject" %>
<%@ page import="jcw.WbemScripting.ISWbemObjectSet" %>
<%@ page import="jcw.WbemScripting.ISWbemProperty" %>
<%@ page import="jcw.WbemScripting.ISWbemServices" %>
<%@ page import="jcw.WbemScripting.SWbemLocator" %>
<%@ page import="jcw.WbemScripting.jcw.ISWbemObjectJCW" %>
<%@ page import="com.inzoom.comjni.ComJniException" %>
<%@ page import="com.inzoom.comjni.IEnumVARIANT" %>
<%@ page import="com.inzoom.comjni.IUnknown" %>
<%@ page import="com.inzoom.comjni.Variant" %>
<%@ page import="com.inzoom.comjni.jcw.IEnumVARIANTJCW" %>

<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.PredicateBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.actions.WebUIUtility" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<!-- This panel provides a searchable interface into the WMI service -->

<page>
<window-popup onload="updateCurrentObjectNames();updateAvailableObjectNames();">

<%@ include file="Configuration.jsp"%>

<%
  /**
   * This allows the user to control how the displayed values are sourced.
   */
  final boolean USE_PREDEFINED_LIST_VALUES = false;

  // This is used to match the proper predicate information for objectNames list type predicate
  final String OBJECT_PREDICATE_NAME = "MSG_OBJECT";

  URLDecoder decoded = new URLDecoder();

  String parentNodes = request.getParameter("parentNodes");
  String NODE_NAMES = null;
  String PRIMARY_NODE_NAMES_WMI_STR = "";
  String EXTERNAL_NODE_NAMES_WMI_STR = "";
  if (parentNodes != null) {
    NODE_NAMES = decoded.decode(parentNodes, "UTF-8");

    // we need to create the node name WMI search strings for the different WMI calls (this is to support seaching multiple nodes)
    PRIMARY_NODE_NAMES_WMI_STR = " PRIMARYNODENAME = '" + NODE_NAMES.replaceAll(",", "' OR PRIMARYNODENAME = '") + "'";
    EXTERNAL_NODE_NAMES_WMI_STR = " CAPTION = '" + NODE_NAMES.replaceAll(",", "' OR CAPTION = '") + "'";
  }

  // build a filter if necessary
  String filterValue = request.getParameter("ObjectNameFilterValue");
  String filterOps = request.getParameter("ObjectNameFilterOperator");
  if(filterValue != null)
  {
    String value = filterValue;
    String ops = "EQ;";
    if(filterOps.equals("STARTS_WITH"))
    {
      ops = "LIKE;";
      value = value + "*";
    }
    else if(filterOps.equals("ENDS_WITH"))
    {
      ops = "LIKE;";
      value = "*" + value;
    }
    else if(filterOps.equals("CONTAINS"))
    {
      ops = "LIKE;";
      value = "*" + value +"*";
    }
  } else {
    filterValue = "";
    filterValue = "";
  }

  // retrieve the objectName list from the WMI interface
  ArrayList<String> wmiObjectNames = new ArrayList<String>();

  if(USE_PREDEFINED_LIST_VALUES)
  {
    final Iterator<PredicateBean> iter = subscriptionBean.getListPredicateIterator();
    while(iter.hasNext())
    {
      final PredicateBean predicate = iter.next();
      if(predicate.getPredicateName().equals(OBJECT_PREDICATE_NAME))
      {
        wmiObjectNames.addAll(predicate.getPredicateValues());
        break;
      }
    }
  }

  if(wmiObjectNames.isEmpty() && !USE_PREDEFINED_LIST_VALUES && NODE_NAMES != null && NODE_NAMES != "")
  {
    try
    {
        WebUIUtility.initializeJacozoomIfNecessary();
        ISWbemLocator locator = new SWbemLocator();
        ISWbemServices service = locator.connectServer(OM_HOST_URL, OM_NAME_SPACE_URL, OM_USER_NAME, OM_PASSWORD);

        // Retrieve Managed Node ID's
        ISWbemObjectSet nodes = service.execQuery("SELECT NAME FROM OV_MANAGEDNODE WHERE " + PRIMARY_NODE_NAMES_WMI_STR );
        String NodeIds = null;

        if(nodes.getCount() > 0)
        {
            IUnknown unk = nodes.get_NewEnum();
            nodes.release();
            IEnumVARIANT ev = IEnumVARIANTJCW.getIEnumVARIANTFromUnknown(unk);
            unk.release();
            int[] fetched = new int[1];
            Variant[] rv = new Variant[] { new Variant() };
            do
            {
                ev.next(1, rv, fetched);
                if(fetched[0] != 0)
                {
                    unk = rv[0].getUnknown();
                    // this causes ComJniException rv[0].release();
                    ISWbemObject obj = ISWbemObjectJCW.getISWbemObjectFromUnknown(unk);
                    unk.release();
                    try
                    {
                        ISWbemProperty property = obj.getProperties_().item("NAME");
                        Variant var = property.getValue();
                        String value = var.getString();
                        if (NodeIds == null)
                          NodeIds = "'" + (StringEscapeUtils.escapeXml(value)) + "'";
                        else
                          NodeIds = NodeIds+", '" + (StringEscapeUtils.escapeXml(value) + "'");

                    }
                    finally
                    {
                        obj.release();
                    }
                }
            } while(fetched[0] != 0);
        }

        // Retrieve External Node ID's
        ISWbemObjectSet objectsExt = service.execQuery("SELECT NAME FROM OV_EXTERNALNODE WHERE " + EXTERNAL_NODE_NAMES_WMI_STR);

        if(objectsExt.getCount() > 0)
        {
            IUnknown unk = objectsExt.get_NewEnum();
            objectsExt.release();
            IEnumVARIANT ev = IEnumVARIANTJCW.getIEnumVARIANTFromUnknown(unk);
            unk.release();
            int[] fetched = new int[1];
            Variant[] rv = new Variant[] { new Variant() };
            do
            {
                ev.next(1, rv, fetched);
                if(fetched[0] != 0)
                {
                    unk = rv[0].getUnknown();
                    // this causes ComJniException rv[0].release();
                    ISWbemObject obj = ISWbemObjectJCW.getISWbemObjectFromUnknown(unk);
                    unk.release();
                    try
                    {
                        ISWbemProperty property = obj.getProperties_().item("NAME");
                        Variant var = property.getValue();
                        String value = var.getString();
                        if (NodeIds == null)
                          NodeIds = "'" + (StringEscapeUtils.escapeXml(value)) + "'";
                        else
                          NodeIds = NodeIds+", '" + (StringEscapeUtils.escapeXml(value) + "'");
                    }
                    finally
                    {
                        obj.release();
                    }
                }
            } while(fetched[0] != 0);
        }

        ISWbemObjectSet objects;
        if (NodeIds == null) {
          objects = service.execQuery("SELECT * FROM OV_MESSAGE");
        } else {
          String OV_MESSAGE_NODE_IDS_WMI_STR = " NODENAME = " + NodeIds.replaceAll(",", " OR NODENAME = ");
          objects = service.execQuery("SELECT * FROM OV_MESSAGE WHERE " + OV_MESSAGE_NODE_IDS_WMI_STR );
        }

        if(objects.getCount() > 0)
        {
            IUnknown unk = objects.get_NewEnum();
            objects.release();
            IEnumVARIANT ev = IEnumVARIANTJCW.getIEnumVARIANTFromUnknown(unk);
            unk.release();
            int[] fetched = new int[1];
            Variant[] rv = new Variant[] { new Variant() };
            do
            {
                ev.next(1, rv, fetched);
                if(fetched[0] != 0)
                {
                    unk = rv[0].getUnknown();
                    // this causes ComJniException rv[0].release();
                    ISWbemObject obj = ISWbemObjectJCW.getISWbemObjectFromUnknown(unk);
                    unk.release();
                    try
                    {
                        ISWbemProperty property = obj.getProperties_().item("OBJECT");
                        Variant var = property.getValue();
                        String value = var.getString();
                        if (!wmiObjectNames.contains(StringEscapeUtils.escapeXml(value.trim()))) {
                          wmiObjectNames.add(StringEscapeUtils.escapeXml(value.trim()));
                        }
                    }
                    finally
                    {
                        obj.release();
                    }
                }
            } while(fetched[0] != 0);
        }

        service.release();
        locator.release();

        // sort the collection
        Collections.sort(wmiObjectNames);
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      out.println("<div class=\"system-msg-error\">Unexpected exception occurred: " + ex.getMessage() + "</div>");
    }
  }

  // build the selected list of host names from existing subscription
  ArrayList<String> selectedObjectNames = new ArrayList<String>();

  if(request.getParameter("selectedObjectNames") != null)
  {
    selectedObjectNames.addAll(Arrays.asList(request.getParameterValues("selectedObjectNames")));
  }
  else
  {
    final Iterator<PredicateBean> iter = subscriptionBean.getListPredicateIterator();
    while(iter.hasNext())
    {
      final PredicateBean predicate = iter.next();
      if(predicate.getPredicateName().equals(OBJECT_PREDICATE_NAME))
      {
        selectedObjectNames.addAll(predicate.getSelectedValues());
        break;
      }
    }
  }

%>

<script type="text/javascript">
  function escapeREText(text)
  {
    if (!arguments.callee.sRE) {
      var specials = [
        '/', '.', '*', '+', '?', '|',
        '(', ')', '[', ']', '{', '}', '\\'
      ];
      arguments.callee.sRE = new RegExp(
        '(\\' + specials.join('|\\') + ')', 'g'
      );
    }
    return text.replace(arguments.callee.sRE, '\\\\$1');
  }

  function selectAllTargetOptions(theForm, name)
  {
    var target = theForm[name];
    // first select all of the options that match the regexp
    selectAllOptions(target);
  }

  // Adds the list of selected items selected in the parent
  // window to its list.
  function updateCurrentObjectNames()
  {
    var theForm = document.forms['POPUP_FORM'];
    var target = theForm['objectNames'];
    var parentForm = self.opener.document.forms[0];
    var source = parentForm['PREDICATE_VALUE_<%=OBJECT_PREDICATE_NAME%>'];
    // clear the left list
    removeAllOptions(target);
    if(source.options.length != 0)
    {
      // copy from source to left list
      copyAllOptions(source, target);
    }
  }

  // Update the parentsNodes with the date from the parent form's node names
  // These nodes are then sent via a POST back to the form when we do the first "Get Policies"
  function updateNodeNames()
  {
    <%
    if (NODE_NAMES == null)
    {
      %>
      var theForm = document.forms['POPUP_FORM'];
      var target = theForm['policyNames'];
      var parentForm = self.opener.document.forms[0];
      var nodeSource = parentForm['PREDICATE_VALUE_NODE'];
      var nodeName = "";
      for (var i=0; i &lt; nodeSource.options.length; i++) {
        if (i != 0)
          nodeName = nodeName + "," + nodeSource.options[i].value;
        else
          nodeName = nodeName + nodeSource.options[i].value;
      }
      var parentNodes = theForm['parentNodes'];
      parentNodes.value = nodeName;
      theForm.submit();
      <%
    }
    %>
  }

  function setSelectionOptions(source, target)
  {
    // clear the left list
    removeAllOptions(target);
    // copy from source to left list
    copySelectedOptions(source, target);
  }

  function updateParentForm(theForm)
  {
    selectAllTargetOptions(theForm, 'objectNames');
    var source = theForm['objectNames'];
    self.opener.updateCurrentObjects(source);
    self.close();
    return true;
  }

  function updateAvailableObjectNames()
  {
    var theForm = document.forms['POPUP_FORM'];
    var from = theForm['wmiObjectNames'];
    var to = theForm['objectNames.unselected'];
    var target = theForm['objectNames'];

    var regex = getFilterRegexp(theForm);
    // first select all of the options that match the regexp
    selectOnlyMatchingOptions(from, regex);
    // unselect items that already exist in the right list
    unselectMatchingOptions(from, target);
    // clear the left list
    removeAllOptions(to);
    // copy from source to left list
    copySelectedOptions(from, to);
    return false;
  }

  function getFilterRegexp(theForm)
  {
    var ops = theForm['ObjectNameFilterOperator'].value;
    var value = theForm['ObjectNameFilterValue'].value;

    var regex = ".*";
    if(value != "") {
      regex = "";
      if(ops == "CONTAINS" || ops == "ENDS_WITH") {
        regex = ".*";
      }
      regex = regex + escapeREText(value);
      if(ops == "CONTAINS" || ops == "STARTS_WITH") {
        regex = regex + ".*";
      }
    }
    return "^" + regex + "$";
  }

  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  function unselectMatchingOptions(from, to)
  {
    for (var i=0; i&lt;from.options.length; i++)
    {
      var o = from.options[i];
      if (o.selected) {
        for (var j=0; j&lt;to.options.length; j++) {
          var op = to.options[j];
          if (o.value == op.value) {
            o.selected = false;
          }
        }
      }
    }
  }

  function transferRight()
  {
    objectNames_jsWidget.forms_transferRight();
  }

  function transferLeft()
  {
    removeMatchingOptions(objectNames_jsWidget.form, objectNames_jsWidget.right);
    objectNames_jsWidget.forms_transferLeft();
  }

  // this will remove any options from the specified list that do not match the search filter criteria
  function removeMatchingOptions(theForm, from)
  {
    var re = new RegExp(getFilterRegexp(theForm));
    for(var i=(from.options.length-1); i>=0; i--)
    {
      var o = from.options[i];
      if(o.selected) {
        if(!re.test(o.text)) {
          from.options[i] = null;
        }
      }
    }
  }

</script>

  <form-template name="POPUP_FORM"
                 onsubmit="selectAllTargetOptions(this, 'objectNames');"
                 form-action="jsp/subscription/omw/OMSearchObject.jsp;jsessionid=<%= session.getId() %>?">

<group label="Search Objects">

  <div class="no-list-table-data-title">
    <caption>
      <span>To find a list of available Objects, specify your search criteria below and then click "Get Objects"</span>
    </caption>
  </div>

  <div class="form-group">
    <table>
      <tr>
        <th>Name</th><th>Operator</th><th>Value</th>
      </tr>
      <tr>
        <td>Object</td>
        <td type="template">
          <select id="ObjectNameFilterOperator" name="ObjectNameFilterOperator">
            <option
<%
 if(filterOps == null || filterOps.equals("CONTAINS") || filterOps.equals(""))
 {
%>
 selected="true"
<%
 }
%>
              value="CONTAINS">CONTAINS</option>
            <option
<%
 if(filterOps != null && filterOps.equals("ENDS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="ENDS_WITH">ENDS_WITH</option>
            <option
<%
 if(filterOps != null && filterOps.equals("STARTS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="STARTS_WITH">STARTS_WITH</option>
            <option
<%
 if(filterOps != null && filterOps.equals("MATCHES"))
 {
%>
 selected="true"
<%
 }
%>
              value="MATCHES">MATCHES</option>
          </select>
        </td>
        <td type="template">
          <input id="ObjectNameFilterValue" name="ObjectNameFilterValue" value="<%= filterValue %>"/>
        </td>
      </tr>
    </table>
  </div>

  <div style="display:none;visibility:hidden;">
    <input id="parentNodes" class="hidden" name="parentNodes"/>
  </div>

  <action-button id="refreshButton" label="Get Objects" onclick="updateNodeNames();updateAvailableObjectNames(); return false;" />

</group>

<div class="form-group">

  <script type="text/javascript">var objectNames_jsWidget;</script>

  <div class="double-list-widget">
    <label>Available Objects:</label>
    <br clear="all"/>
    <select style="width:500px;" multiple="0" name="objectNames.unselected" id="objectNames.unselected:input" size="10" ondblclick="transferRight();">
    </select>
  </div>

  <div class="double-list-button-cluster">
    <div class="float-none">
      <span id="addButton">
        <input id="addButton:input" class="double-list-action" name="addButton" type="button"
               onclick="transferRight(); return false;" value="Add &gt;"/>
      </span>
      <br/>
      <span id="removeButton">
        <input id="removeButton:input" class="double-list-action" name="removeButton" type="button"
               onclick="transferLeft(); return false;" value="&lt; Remove"/>
      </span>
    </div>
  </div>

  <div class="double-list-widget">
    <label>Selected Objects:</label>
    <br clear="all"/>
    <select style="width:500px;" multiple="0" name="objectNames" id="objectNames:input" size="10" ondblclick="transferLeft();">
<%
  Collections.sort(selectedObjectNames, String.CASE_INSENSITIVE_ORDER);
  for (String name : selectedObjectNames)
  {
%>
      <option value="<%= name%>"><%= name%></option>
<%
  }
%>
    </select>
  </div>
  <script type="text/javascript">objectNames_jsWidget = forms_createOptionTransfer('objectNames', false);</script>
</div>

<!-- hidden component for javascript processing -->
<div style="display:none;visibility:hidden;">
    <select multiple="0" name="wmiObjectNames" size="0">
<%
  Collections.sort(wmiObjectNames, String.CASE_INSENSITIVE_ORDER);
  for (String name : wmiObjectNames)
  {
%>
      <option value="<%= name%>"><%= name%></option>
<%
  }
%>
    </select>
</div>

  <action-button id="submitButton" label="Save" onclick="return updateParentForm(this.form);" />

  </form-template>

</window-popup>
</page>
